package com.zhongshu.reward.server.core.domain;

import com.github.microservice.components.data.mongo.mongo.domain.SuperEntity;
import com.zhongshu.reward.client.type.ComputationType;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.mongodb.core.mapping.Document;

import java.math.BigDecimal;

/**
 * @author wjf
 * @date 2024/8/7
 */
@Data
@Builder
@Document
@AllArgsConstructor
@NoArgsConstructor
public class InviteReceiptsRuler extends SuperEntity {

    @ApiModelProperty("规则名称")
    private String roleName;

    @ApiModelProperty("套餐id")
    private String setMealId;

    @ApiModelProperty("计算规则:固定、百分比")
    private ComputationType computation;

    @ApiModelProperty("金额额度")
    private BigDecimal baseTotal;

    @ApiModelProperty("生效状态")
    private boolean disable;

    @ApiModelProperty("生效范围是否所有")
    private boolean isALL = true;

}
