package com.zhongshu.reward.server.core.domain;

import com.github.microservice.components.data.mongo.mongo.domain.SuperEntity;
import com.zhongshu.reward.client.type.DataState;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.Document;

import java.math.BigDecimal;

/**
 * 钱包
 * @author wjf
 * @date 2024/8/5
 */
@Data
@Builder
@Document
@AllArgsConstructor
@NoArgsConstructor
public class Wallet extends SuperEntity {

    /**
     * 用户id
     */
    @Indexed
    private String userId;

    /**
     * 商铺id
     */
    @Indexed
    private String shopId;


    /**
     * 账户余额(可提现金额)
     */
    @Indexed
    private BigDecimal amount = BigDecimal.ZERO;

    /**
     * 未结算金额
     */
    @Indexed
    private BigDecimal waitAmount = BigDecimal.ZERO;

    /**
     * 当日已提现金额
     */
    private BigDecimal todayTransferAmount = BigDecimal.ZERO;

    /**
     * 钱包状态
     */
    @Indexed
    private DataState dataState;

}
