package com.zhongshu.reward.server.core.service;

import com.github.microservice.auth.security.helper.AuthHelper;
import com.github.microservice.core.util.iterator.IteratorUtil;
import com.zhongshu.reward.client.model.InviteSuccessModel;
import com.zhongshu.reward.client.ret.ResultContent;
import com.zhongshu.reward.server.core.dao.InviteRecordDao;
import com.zhongshu.reward.server.core.dao.WalletReceiptsDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * @author wjf
 * @date 2024/8/13
 */
@Service
public class StatisticsService {

    @Autowired
    AuthHelper authHelper;

    @Autowired
    InviteRecordDao inviteRecordDao;

    @Autowired
    WalletReceiptsDao walletReceiptsDao;

    public Object myInvite(){
        String userId = authHelper.getCurrentUser().getUserId();
        Integer inviteCount = inviteRecordDao.countByInviteUserId(userId);
        List<InviteSuccessModel> inviteSuccessModels = walletReceiptsDao.myInvite(userId);
        BigDecimal totalAmount = BigDecimal.ZERO;
        if (!inviteSuccessModels.isEmpty()){
            totalAmount = inviteSuccessModels.stream().map(InviteSuccessModel::getTotalAmount).filter(Objects::nonNull).reduce(BigDecimal.ZERO, BigDecimal::add);
        }
        return ResultContent.buildContent(Map.of("inviteCount", inviteCount, "success", inviteSuccessModels.size(), "totalAmount", totalAmount));
    }
}
